# zbot/generic.py
#
#

"""generic functions """

## IMPORTS

import logging
import email
import time

## GENERICS

def reduced(*args, **kwargs):
    obj = args[0]
    res = []
    for key in obj.keys():
        k = str(key)
        if k.startswith("_"): continue 
        if key in ["args", "rest", "first"]: continue   
        res.append(key)
    return res

def feed(text):
    from zbot import Object
    result = []
    chunks = text.split("\r\n")
    for chunk in chunks:
        obj = Object().feed(chunk)
        result.append(obj)        
    return result

def dispatch(target, event, cmnd, *args, **kwargs):
    try: functions = target[cmnd]
    except KeyError: return False
    for func in functions: func(event) 
    return event

def resolve(*args, **kwargs):
    from zbot import kernel
    event = args[0]
    event.prepare()
    e = None
    if not event.is_cmnd: e = dispatch(event._target, event, event.etype, *args, **kwargs)
    if not e: e = dispatch(kernel.cmnds, event, event.ucmnd, *args, **kwargs) 
    if not e: e = dispatch(kernel.tests, event, event.ucmnd, *args, **kwargs)
    return e

def need_skip(obj, black=[], white=[]):
    needskip = False
    try: value = obj.get_content_type()
    except AttributeError: return False
    for w in white:
        if w not in value: needskip = True
    for b in black:
        if b in value: needskip = True
    return needskip
